> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://docs.nvidia.com/infra-controller/llms.txt.
> For full documentation content, see https://docs.nvidia.com/infra-controller/llms-full.txt.

# Update Expected Power Shelf

PATCH https://carbide-rest-api.carbide.svc.cluster.local/v2/org/{org}/carbide/expected-power-shelf/{expectedPowerShelfId}
Content-Type: application/json

Update an existing Expected Power Shelf by ID.

Org must have an Infrastructure Provider entity. User must have `FORGE_PROVIDER_ADMIN` role.

Infrastructure Provider must own the Expected Power Shelf.

Alternatively, Tenant Admins with `TargetedInstanceCreation` capability can also update Expected Power Shelves if they have an account with the Site's Infrastructure Provider.

Reference: https://docs.nvidia.com/infra-controller/infra-controller/rest-api-reference/api-reference/expected-power-shelf/update-expected-power-shelf

## OpenAPI Specification

```yaml
openapi: 3.1.0
info:
  title: NCX Infra Controller REST API
  version: 1.0.0
paths:
  /v2/org/{org}/carbide/expected-power-shelf/{expectedPowerShelfId}:
    patch:
      operationId: update-expected-power-shelf
      summary: Update Expected Power Shelf
      description: >-
        Update an existing Expected Power Shelf by ID.


        Org must have an Infrastructure Provider entity. User must have
        `FORGE_PROVIDER_ADMIN` role.


        Infrastructure Provider must own the Expected Power Shelf.


        Alternatively, Tenant Admins with `TargetedInstanceCreation` capability
        can also update Expected Power Shelves if they have an account with the
        Site's Infrastructure Provider.
      tags:
        - subpackage_expectedPowerShelf
      parameters:
        - name: org
          in: path
          required: true
          schema:
            type: string
        - name: expectedPowerShelfId
          in: path
          required: true
          schema:
            type: string
        - name: Authorization
          in: header
          description: >-
            ```

            export JWT_BEARER_TOKEN="<jwt-bearer-token>"


            # Example org name: "acme-inc

            export ORG_NAME=<org-name>


            # Use the JWT bearer token in your API request auth header:

            curl -v -X GET -H "Content-Type: application/json" -H
            "Authorization: Bearer $JWT_BEARER_TOKEN"
            https://carbide-rest-api.carbide.svc.cluster.local/v2/org/$ORG_NAME/carbide/user/current

            ```
          required: true
          schema:
            type: string
      responses:
        '200':
          description: OK
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ExpectedPowerShelf'
        '400':
          description: Error response when request data cannot be validated
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/CarbideAPIError'
        '403':
          description: >-
            Error response when user is not authorized to call an endpoint or
            retrieve/modify objects
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/CarbideAPIError'
        '404':
          description: Error response when requested object is not found
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/CarbideAPIError'
      requestBody:
        description: Expected Power Shelf update request
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/ExpectedPowerShelfUpdateRequest'
servers:
  - url: https://carbide-rest-api.carbide.svc.cluster.local
components:
  schemas:
    Labels:
      type: object
      additionalProperties:
        type: string
      title: Labels
    ExpectedPowerShelfUpdateRequest:
      type: object
      properties:
        id:
          type:
            - string
            - 'null'
          format: uuid
          description: >-
            ID of the Expected Power Shelf to update (ignored for single update,
            used for identification in batch operations).
        bmcMacAddress:
          type:
            - string
            - 'null'
          description: >-
            MAC address of the Expected Power Shelf's BMC (Baseboard Management
            Controller)
        defaultBmcUsername:
          type:
            - string
            - 'null'
          description: Username for accessing the Expected Power Shelf's BMC
        defaultBmcPassword:
          type:
            - string
            - 'null'
          description: Password for accessing the Expected Power Shelf's BMC
        shelfSerialNumber:
          type:
            - string
            - 'null'
          description: Serial number of the Expected Power Shelf
        ipAddress:
          type:
            - string
            - 'null'
          description: IP address of the Expected Power Shelf
        rackId:
          type:
            - string
            - 'null'
          description: Optional rack identifier for this component
        name:
          type:
            - string
            - 'null'
          description: Display name for this component
        manufacturer:
          type:
            - string
            - 'null'
          description: Manufacturer of this component
        model:
          type:
            - string
            - 'null'
          description: Model of this component
        description:
          type:
            - string
            - 'null'
          description: Description of this component
        firmwareVersion:
          type:
            - string
            - 'null'
          description: Firmware version of this component
        slotId:
          type:
            - integer
            - 'null'
          description: Slot ID within the rack
        trayIdx:
          type:
            - integer
            - 'null'
          description: Tray index within the rack
        hostId:
          type:
            - integer
            - 'null'
          description: Host ID within the tray
        labels:
          $ref: '#/components/schemas/Labels'
          description: >-
            User-defined key-value pairs for organizing and categorizing
            Expected Power Shelves
      description: >-
        Request data to update an existing Expected Power Shelf.


        Note: BMC credentials (username/password) are only accepted during
        creation and updates but are not returned in responses.
      title: ExpectedPowerShelfUpdateRequest
    ExpectedPowerShelf:
      type: object
      properties:
        id:
          type: string
          format: uuid
          description: Unique identifier for the Expected Power Shelf
        siteId:
          type: string
          format: uuid
          description: ID of the site the Expected Power Shelf belongs to
        bmcMacAddress:
          type: string
          description: >-
            MAC address of the Expected Power Shelf's BMC (Baseboard Management
            Controller)
        shelfSerialNumber:
          type: string
          description: Serial number of the Expected Power Shelf
        ipAddress:
          type:
            - string
            - 'null'
          description: IP address of the Expected Power Shelf
        rackId:
          type:
            - string
            - 'null'
          description: Optional rack identifier for this component
        name:
          type:
            - string
            - 'null'
          description: Display name for this component
        manufacturer:
          type:
            - string
            - 'null'
          description: Manufacturer of this component
        model:
          type:
            - string
            - 'null'
          description: Model of this component
        description:
          type:
            - string
            - 'null'
          description: Description of this component
        firmwareVersion:
          type:
            - string
            - 'null'
          description: Firmware version of this component
        slotId:
          type:
            - integer
            - 'null'
          description: Slot ID within the rack
        trayIdx:
          type:
            - integer
            - 'null'
          description: Tray index within the rack
        hostId:
          type:
            - integer
            - 'null'
          description: Host ID within the tray
        labels:
          $ref: '#/components/schemas/Labels'
          description: >-
            User-defined key-value pairs for organizing and categorizing
            Expected Power Shelves
        created:
          type: string
          format: date-time
          description: ISO 8601 datetime when the Expected Power Shelf was created
        updated:
          type: string
          format: date-time
          description: ISO 8601 datetime when the Expected Power Shelf was last updated
      description: >-
        An Expected Power Shelf represents a power shelf that is expected to be
        discovered at a site, with hardware identifiers and metadata.


        Note: BMC credentials (username/password) are only accepted during
        creation and updates but are not returned in responses.
      title: ExpectedPowerShelf
    CarbideApiErrorSource:
      type: string
      enum:
        - carbide
      description: Source of the error. Only 'carbide' is supported
      title: CarbideApiErrorSource
    CarbideApiErrorData:
      type: object
      properties: {}
      description: Additional data about the error
      title: CarbideApiErrorData
    CarbideAPIError:
      type: object
      properties:
        source:
          $ref: '#/components/schemas/CarbideApiErrorSource'
          description: Source of the error. Only 'carbide' is supported
        message:
          type: string
          description: Message describing the error
        data:
          oneOf:
            - $ref: '#/components/schemas/CarbideApiErrorData'
            - type: 'null'
          description: Additional data about the error
      description: Describes the error response from NCX Infra Controller REST API
      title: CarbideAPIError
  securitySchemes:
    JWTBearerToken:
      type: http
      scheme: bearer
      description: >-
        ```

        export JWT_BEARER_TOKEN="<jwt-bearer-token>"


        # Example org name: "acme-inc

        export ORG_NAME=<org-name>


        # Use the JWT bearer token in your API request auth header:

        curl -v -X GET -H "Content-Type: application/json" -H "Authorization:
        Bearer $JWT_BEARER_TOKEN"
        https://carbide-rest-api.carbide.svc.cluster.local/v2/org/$ORG_NAME/carbide/user/current

        ```

```

## SDK Code Examples

```python
import requests

url = "https://carbide-rest-api.carbide.svc.cluster.local/v2/org/org/carbide/expected-power-shelf/expectedPowerShelfId"

payload = {
    "defaultBmcUsername": "newadmin",
    "defaultBmcPassword": "newpassword123",
    "shelfSerialNumber": "SHELF-54321",
    "ipAddress": "192.168.1.200",
    "labels": {
        "environment": "staging",
        "rack": "B2"
    }
}
headers = {
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.patch(url, json=payload, headers=headers)

print(response.json())
```

```javascript
const url = 'https://carbide-rest-api.carbide.svc.cluster.local/v2/org/org/carbide/expected-power-shelf/expectedPowerShelfId';
const options = {
  method: 'PATCH',
  headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
  body: '{"defaultBmcUsername":"newadmin","defaultBmcPassword":"newpassword123","shelfSerialNumber":"SHELF-54321","ipAddress":"192.168.1.200","labels":{"environment":"staging","rack":"B2"}}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://carbide-rest-api.carbide.svc.cluster.local/v2/org/org/carbide/expected-power-shelf/expectedPowerShelfId"

	payload := strings.NewReader("{\n  \"defaultBmcUsername\": \"newadmin\",\n  \"defaultBmcPassword\": \"newpassword123\",\n  \"shelfSerialNumber\": \"SHELF-54321\",\n  \"ipAddress\": \"192.168.1.200\",\n  \"labels\": {\n    \"environment\": \"staging\",\n    \"rack\": \"B2\"\n  }\n}")

	req, _ := http.NewRequest("PATCH", url, payload)

	req.Header.Add("Authorization", "Bearer <token>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://carbide-rest-api.carbide.svc.cluster.local/v2/org/org/carbide/expected-power-shelf/expectedPowerShelfId")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Patch.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n  \"defaultBmcUsername\": \"newadmin\",\n  \"defaultBmcPassword\": \"newpassword123\",\n  \"shelfSerialNumber\": \"SHELF-54321\",\n  \"ipAddress\": \"192.168.1.200\",\n  \"labels\": {\n    \"environment\": \"staging\",\n    \"rack\": \"B2\"\n  }\n}"

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.patch("https://carbide-rest-api.carbide.svc.cluster.local/v2/org/org/carbide/expected-power-shelf/expectedPowerShelfId")
  .header("Authorization", "Bearer <token>")
  .header("Content-Type", "application/json")
  .body("{\n  \"defaultBmcUsername\": \"newadmin\",\n  \"defaultBmcPassword\": \"newpassword123\",\n  \"shelfSerialNumber\": \"SHELF-54321\",\n  \"ipAddress\": \"192.168.1.200\",\n  \"labels\": {\n    \"environment\": \"staging\",\n    \"rack\": \"B2\"\n  }\n}")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('PATCH', 'https://carbide-rest-api.carbide.svc.cluster.local/v2/org/org/carbide/expected-power-shelf/expectedPowerShelfId', [
  'body' => '{
  "defaultBmcUsername": "newadmin",
  "defaultBmcPassword": "newpassword123",
  "shelfSerialNumber": "SHELF-54321",
  "ipAddress": "192.168.1.200",
  "labels": {
    "environment": "staging",
    "rack": "B2"
  }
}',
  'headers' => [
    'Authorization' => 'Bearer <token>',
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://carbide-rest-api.carbide.svc.cluster.local/v2/org/org/carbide/expected-power-shelf/expectedPowerShelfId");
var request = new RestRequest(Method.PATCH);
request.AddHeader("Authorization", "Bearer <token>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"defaultBmcUsername\": \"newadmin\",\n  \"defaultBmcPassword\": \"newpassword123\",\n  \"shelfSerialNumber\": \"SHELF-54321\",\n  \"ipAddress\": \"192.168.1.200\",\n  \"labels\": {\n    \"environment\": \"staging\",\n    \"rack\": \"B2\"\n  }\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = [
  "Authorization": "Bearer <token>",
  "Content-Type": "application/json"
]
let parameters = [
  "defaultBmcUsername": "newadmin",
  "defaultBmcPassword": "newpassword123",
  "shelfSerialNumber": "SHELF-54321",
  "ipAddress": "192.168.1.200",
  "labels": [
    "environment": "staging",
    "rack": "B2"
  ]
] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://carbide-rest-api.carbide.svc.cluster.local/v2/org/org/carbide/expected-power-shelf/expectedPowerShelfId")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "PATCH"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```